'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Node2 = require('./Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Base class for all expression nodes.
 *
 * @name Expression
 * @class
 * @abstract
 */

var Expression = function (_Node) {
    _inherits(Expression, _Node);

    function Expression(type, children) {
        _classCallCheck(this, Expression);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Expression).call(this, type, children));

        _this.isExpression = true;
        return _this;
    }

    return Expression;
}(_Node3.default);

exports.default = Expression;
//# sourceMappingURL=Expression.js.map