'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var binaryOperators = {
    '==': true,
    '!=': true,
    '===': true,
    '!==': true,
    '<': true,
    '<=': true,
    '>': true,
    '>=': true,
    '<<': true,
    '>>': true,
    '>>>': true,
    '+': true,
    '-': true,
    '*': true,
    '/': true,
    '%': true,
    '|': true,
    '^': true,
    '&': true,
    'in': true,
    'instanceof': true,
    '**': true
};

var BinaryExpression = function (_Expression) {
    _inherits(BinaryExpression, _Expression);

    // TODO: Should respect operator precedence: putting "a + b" before " * b" without parens should raise an error.

    function BinaryExpression(childNodes) {
        _classCallCheck(this, BinaryExpression);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(BinaryExpression).call(this, 'BinaryExpression', childNodes));
    }

    _createClass(BinaryExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var left = children.passExpression();
            children.skipNonCode();
            if (children.currentElement.type === 'Punctuator' || children.currentElement.type === 'Keyword') {
                children.assertToken(children.currentElement.type, binaryOperators);
            } else {
                children.assertToken('Punctuator');
            }
            var operator = children.passToken().value;
            children.skipNonCode();
            var right = children.passExpression();
            children.assertEnd();

            this.left = left;
            this.operator = operator;
            this.right = right;
        }
    }]);

    return BinaryExpression;
}(_Expression3.default);

exports.default = BinaryExpression;
//# sourceMappingURL=BinaryExpression.js.map