'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockStatement = function (_Statement) {
    _inherits(BlockStatement, _Statement);

    function BlockStatement(childNodes) {
        _classCallCheck(this, BlockStatement);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(BlockStatement).call(this, 'BlockStatement', childNodes));
    }

    _createClass(BlockStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var body = [];
            var directives = [];

            children.assertToken('Punctuator', '{');
            children.moveNext();
            children.skipNonCode();

            while (children.isNode('Directive')) {
                directives.push(children.passNode());
                children.skipNonCode();
            }

            while (!children.isToken('Punctuator', '}')) {
                body.push(children.passStatement());
                children.skipNonCode();
            }

            children.passToken('Punctuator', '}');
            children.assertEnd();

            this.body = body;
            this.directives = directives;
        }
    }]);

    return BlockStatement;
}(_Statement3.default);

exports.default = BlockStatement;
//# sourceMappingURL=BlockStatement.js.map