'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var _getFunctionParams = require('./utils/getFunctionParams');

var _getFunctionParams2 = _interopRequireDefault(_getFunctionParams);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getterAndSetter = {
    get: true,
    set: true
};

var ClassMethod = function (_Node) {
    _inherits(ClassMethod, _Node);

    function ClassMethod(childNodes) {
        _classCallCheck(this, ClassMethod);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ClassMethod).call(this, 'ClassMethod', childNodes));

        _this.isFunction = true;
        return _this;
    }

    _createClass(ClassMethod, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var key = void 0;
            var computed = void 0;
            var kind = void 0;
            var staticMember = false;
            var generator = false;
            var async = false;
            var params = void 0;

            if (children.isToken('Identifier', 'static')) {
                staticMember = true;
                children.passToken();
                children.skipNonCode();
            }

            if (children.isToken('Identifier', 'async')) {
                async = true;
                children.passToken();
                children.skipNonCode();
            }

            if (children.isToken('Identifier', getterAndSetter)) {
                kind = children.currentElement.value;
                children.passToken();
                children.skipNonCode();
            } else {
                kind = 'method';
                if (children.isToken('Punctuator', '*')) {
                    generator = true;
                    children.passToken();
                    children.skipNonCode();
                }
            }

            if (children.isNode('Identifier')) {
                computed = false;
                key = children.passNode();
                if (kind === 'method' && key.type === 'Identifier' && key.name === 'constructor') {
                    kind = 'constructor';
                }
                children.skipNonCode();
            } else {
                computed = true;
                children.passToken('Punctuator', '[');
                children.skipNonCode();
                key = children.passExpression();
                children.skipNonCode();
                children.passToken('Punctuator', ']');
                children.skipNonCode();
            }

            if (children.isToken('Punctuator', '*')) {
                generator = true;
                children.moveNext();
                children.skipNonCode();
            }

            if (children.isNode('Identifier')) {
                id = children.passNode();
                children.skipNonCode();
            }

            params = (0, _getFunctionParams2.default)(children);
            children.skipNonCode();

            var body = children.passStatement();

            children.assertEnd();

            this.params = params;
            this.async = async;
            this.body = body;
            this.generator = generator;
            this.kind = kind;
            this.key = key;
            this.computed = computed;
            this.static = staticMember;
        }
    }]);

    return ClassMethod;
}(_Node3.default);

exports.default = ClassMethod;
//# sourceMappingURL=ClassMethod.js.map