'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var _getFunctionParams = require('./utils/getFunctionParams');

var _getFunctionParams2 = _interopRequireDefault(_getFunctionParams);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FunctionExpression = function (_Expression) {
    _inherits(FunctionExpression, _Expression);

    // TODO: get params from Property in case of setter

    function FunctionExpression(childNodes) {
        _classCallCheck(this, FunctionExpression);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(FunctionExpression).call(this, 'FunctionExpression', childNodes));

        _this._short = false;
        _this._generatorFromProperty = false;
        _this.expression = false;
        _this.isFunction = true;
        return _this;
    }

    _createClass(FunctionExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var params = [];
            var id = null;
            var generator = false;
            var async = false;
            var short = false;

            if (children.isToken('Punctuator', '(')) {
                params = (0, _getFunctionParams2.default)(children);
                children.skipNonCode();
            } else {
                if (children.isToken('Identifier', 'async')) {
                    async = true;
                    children.passToken('Identifier', 'async');
                    children.skipNonCode();
                }

                children.passToken('Keyword', 'function');
                children.skipNonCode();

                if (children.isToken('Punctuator', '*')) {
                    generator = true;
                    children.moveNext();
                    children.skipNonCode();
                }

                if (children.isNode('Identifier')) {
                    id = children.passNode();
                    children.skipNonCode();
                }

                params = (0, _getFunctionParams2.default)(children);
                children.skipNonCode();
            }

            var body = children.passStatement();

            children.assertEnd();

            this.async = async;
            this.id = id;
            this.params = params;
            this.body = body;
            this.generator = generator;
            this._short = short;
        }
    }, {
        key: '_onSetParentElement',
        value: function _onSetParentElement(parentElement) {
            if (parentElement && (parentElement.type === 'Property' || parentElement.type === 'ClassMethod')) {
                this._short = true;
                this._generatorFromProperty = parentElement._generator;
            } else {
                this._short = false;
                this._generatorFromProperty = false;
            }
            this.generator = this._short ? this._generatorFromProperty : this.generator;
        }
    }]);

    return FunctionExpression;
}(_Expression3.default);

exports.default = FunctionExpression;
//# sourceMappingURL=FunctionExpression.js.map