'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IfStatement = function (_Statement) {
    _inherits(IfStatement, _Statement);

    function IfStatement(childNodes) {
        _classCallCheck(this, IfStatement);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(IfStatement).call(this, 'IfStatement', childNodes));
    }

    _createClass(IfStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'if');
            children.skipNonCode();

            children.passToken('Punctuator', '(');
            children.skipNonCode();

            var test = children.passExpression();
            children.skipNonCode();

            children.passToken('Punctuator', ')');
            children.skipNonCode();

            var consequent = children.passStatement();

            children.skipNonCode();

            var alternate = null;
            if (children.isToken('Keyword', 'else')) {
                children.moveNext();
                children.skipNonCode();
                alternate = children.passStatement();
            }

            children.assertEnd();

            this.test = test;
            this.consequent = consequent;
            this.alternate = alternate;
        }
    }]);

    return IfStatement;
}(_Statement3.default);

exports.default = IfStatement;
//# sourceMappingURL=IfStatement.js.map