'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var _getFunctionParams = require('./utils/getFunctionParams');

var _getFunctionParams2 = _interopRequireDefault(_getFunctionParams);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getterAndSetter = {
    get: true,
    set: true
};

var ObjectMethod = function (_Node) {
    _inherits(ObjectMethod, _Node);

    function ObjectMethod(childNodes) {
        _classCallCheck(this, ObjectMethod);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectMethod).call(this, 'ObjectMethod', childNodes));

        _this.isFunction = true;
        return _this;
    }

    _createClass(ObjectMethod, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var key = void 0;
            var value = void 0;
            var generator = false;
            var method = false;
            var computed = false;
            var kind = void 0;
            var params = [];
            var body = void 0;

            if (children.isToken('Punctuator', '*')) {
                children.passToken();
                children.skipNonCode();
                generator = true;
            }

            if (children.isToken('Identifier', getterAndSetter)) {
                kind = children.currentElement.value;

                children.passToken('Identifier');
                children.skipNonCode();

                computed = children.isToken('Punctuator', '[');
                key = readKey(children);

                children.skipNonCode();

                params = (0, _getFunctionParams2.default)(children);
                children.skipNonCode();

                body = children.passNode('BlockStatement');
            } else {
                kind = 'method';
                computed = children.isToken('Punctuator', '[');
                key = readKey(children);

                children.skipNonCode();

                if (children.isToken('Punctuator')) {
                    method = true;

                    params = (0, _getFunctionParams2.default)(children);
                    children.skipNonCode();

                    body = children.passNode('BlockStatement');
                } else {
                    children.passToken('Punctuator', ':');
                    children.skipNonCode();
                    if (children.currentElement.isPattern) {
                        value = children.passPattern();
                    } else {
                        value = children.passExpression();
                    }
                }
            }

            children.assertEnd();

            this._generator = generator;
            this.kind = kind;
            this.key = key;
            this.value = value;
            this.computed = computed;
            this.method = method;
            this.params = params;
            this.body = body;
        }
    }]);

    return ObjectMethod;
}(_Node3.default);

exports.default = ObjectMethod;


function readKey(children) {
    if (children.isNode('StringLiteral') || children.isNode('Identifier')) {
        return children.passNode();
    } else {
        children.passToken('Punctuator', '[');
        children.skipNonCode();
        var result = children.passExpression();
        children.skipNonCode();
        children.passToken('Punctuator', ']');
        return result;
    }
}
//# sourceMappingURL=ObjectMethod.js.map