'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObjectProperty = function (_Node) {
    _inherits(ObjectProperty, _Node);

    function ObjectProperty(childNodes) {
        _classCallCheck(this, ObjectProperty);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectProperty).call(this, 'ObjectProperty', childNodes));
    }

    _createClass(ObjectProperty, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var key = void 0;
            var value = void 0;
            var shorthand = false;
            var computed = false;

            // Hack :/
            // See https://github.com/babel/babylon/issues/49
            if (children._elements.length === 2 && children._elements[1].type === 'AssignmentPattern') {
                children.currentElement.getSourceCode = function () {
                    return '';
                };
            }

            computed = children.isToken('Punctuator', '[');
            key = readKey(children);

            if (children.isNode('AssignmentPattern')) {
                value = children.passNode();
            } else if (children.isEnd && key.type === 'Identifier') {
                shorthand = true;
                value = key;
            } else {
                children.skipNonCode();
                if (children.isNode('FunctionExpression')) {
                    value = children.passNode('FunctionExpression');
                } else {
                    children.passToken('Punctuator', ':');
                    children.skipNonCode();
                    if (children.currentElement.isPattern) {
                        value = children.passPattern();
                    } else {
                        value = children.passExpression();
                    }
                }
            }

            children.assertEnd();

            this.key = key;
            this.value = value;
            this.shorthand = shorthand;
            this.computed = computed;
        }
    }]);

    return ObjectProperty;
}(_Node3.default);

exports.default = ObjectProperty;


function readKey(children) {
    if (children.isNode('StringLiteral') || children.isNode('NumericLiteral') || children.isNode('Identifier')) {
        return children.passNode();
    } else {
        children.passToken('Punctuator', '[');
        children.skipNonCode();
        var result = children.passExpression();
        children.skipNonCode();
        children.passToken('Punctuator', ']');
        return result;
    }
}
//# sourceMappingURL=ObjectProperty.js.map