'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TemplateElement = function (_Node) {
    _inherits(TemplateElement, _Node);

    function TemplateElement(childNodes) {
        _classCallCheck(this, TemplateElement);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TemplateElement).call(this, 'TemplateElement', childNodes));
    }

    _createClass(TemplateElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var templateToken = children.passToken('Template');

            var tail = false;
            var value = {
                cooked: templateToken.value,
                raw: templateToken.getSourceCode()
            };

            children.assertEnd();

            this.tail = tail;
            this.value = value;
        }
    }]);

    return TemplateElement;
}(_Node3.default);

exports.default = TemplateElement;
//# sourceMappingURL=TemplateElement.js.map