'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TemplateLiteral = function (_Expression) {
    _inherits(TemplateLiteral, _Expression);

    function TemplateLiteral(childNodes) {
        _classCallCheck(this, TemplateLiteral);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TemplateLiteral).call(this, 'TemplateLiteral', childNodes));
    }

    _createClass(TemplateLiteral, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var quasis = [];
            var expressions = [];

            children.passToken('Punctuator', '`');
            while (!children.isToken('Punctuator', '`')) {
                if (children.isNode('TemplateElement')) {
                    quasis.push(children.passNode('TemplateElement'));
                } else {
                    children.passToken('Punctuator', '${');
                    children.skipNonCode();
                    expressions.push(children.passExpression());
                    children.skipNonCode();
                    children.passToken('Punctuator', '}');
                }
            }
            children.passToken('Punctuator', '`');

            if (quasis.length > 0) {
                quasis[quasis.length - 1].tail = true;
            }

            this.quasis = quasis;
            this.expressions = expressions;
        }
    }]);

    return TemplateLiteral;
}(_Expression3.default);

exports.default = TemplateLiteral;
//# sourceMappingURL=TemplateLiteral.js.map