'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Reference = function () {
    function Reference(_ref) {
        var node = _ref.node;
        var scope = _ref.scope;
        var read = _ref.read;
        var write = _ref.write;
        var type = _ref.type;

        _classCallCheck(this, Reference);

        this.node = node;
        this.scope = scope;
        this.read = read;
        this.write = write;
        this.type = type;
    }

    _createClass(Reference, [{
        key: 'isRead',
        value: function isRead() {
            return this.read;
        }
    }, {
        key: 'isWrite',
        value: function isWrite() {
            return this.write;
        }
    }, {
        key: 'isReadOnly',
        value: function isReadOnly() {
            return this.read && !this.write;
        }
    }, {
        key: 'isWriteOnly',
        value: function isWriteOnly() {
            return !this.read && this.write;
        }
    }, {
        key: 'isReadWrite',
        value: function isReadWrite() {
            return this.read && this.write;
        }
    }]);

    return Reference;
}();

exports.default = Reference;
//# sourceMappingURL=Reference.js.map