'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ClassExpression = function (_Expression) {
    _inherits(ClassExpression, _Expression);

    function ClassExpression(childNodes) {
        _classCallCheck(this, ClassExpression);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(ClassExpression).call(this, 'ClassExpression', childNodes));
    }

    _createClass(ClassExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'class');
            children.skipNonCode();

            var id = null;
            if (!children.isToken('Keyword', 'extends') && !children.isNode('ClassBody')) {
                id = children.passNode('Identifier');
                children.skipNonCode();
            }

            var superClass = null;
            if (children.isToken('Keyword', 'extends')) {
                children.passToken('Keyword', 'extends');
                children.skipNonCode();
                superClass = children.passExpression();
                children.skipNonCode();
            }

            var body = children.passNode('ClassBody');
            children.assertEnd();

            this.id = id;
            this.superClass = superClass;
            this.body = body;
        }
    }]);

    return ClassExpression;
}(_Expression3.default);

exports.default = ClassExpression;
//# sourceMappingURL=ClassExpression.js.map