'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ClassProperty = function (_Node) {
    _inherits(ClassProperty, _Node);

    function ClassProperty(childNodes) {
        _classCallCheck(this, ClassProperty);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(ClassProperty).call(this, 'ClassProperty', childNodes));
    }

    _createClass(ClassProperty, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            this.static = false;
            this.value = null;

            if (children.isToken('Identifier', 'static')) {
                this.static = true;
                children.passToken();
                children.skipNonCode();
            }

            this.key = children.passAssignable();
            children.skipNonCode();

            if (children.isToken('Punctuator', '=')) {
                children.passToken('Punctuator', '=');
                children.skipNonCode();

                this.value = children.passNode();
            }

            children.assertEnd();

            // What is computed Class property?
            // See https://github.com/jeffmo/es-class-fields-and-static-properties/issues/33
            // It seems babylon doesn't support it at this stage
            this.computed = false;
        }
    }]);

    return ClassProperty;
}(_Node3.default);

exports.default = ClassProperty;
//# sourceMappingURL=ClassProperty.js.map