'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ModuleDeclaration2 = require('../ModuleDeclaration');

var _ModuleDeclaration3 = _interopRequireDefault(_ModuleDeclaration2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ExportNamedDeclaration = function (_ModuleDeclaration) {
    _inherits(ExportNamedDeclaration, _ModuleDeclaration);

    function ExportNamedDeclaration(childNodes) {
        _classCallCheck(this, ExportNamedDeclaration);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(ExportNamedDeclaration).call(this, 'ExportNamedDeclaration', childNodes));
    }

    _createClass(ExportNamedDeclaration, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'export');
            children.skipNonCode();

            var declaration = null;
            var specifiers = [];
            var source = null;

            if (children.isNode('VariableDeclaration') || children.isNode('FunctionDeclaration') || children.isNode('ClassDeclaration')) {
                declaration = children.passStatement();
            } else {
                // es2015 exports
                if (children.isToken('Punctuator', '{')) {
                    children.passToken('Punctuator', '{');
                    children.skipNonCode();
                    while (!children.isToken('Punctuator', '}')) {
                        specifiers.push(children.passModuleSpecifier());
                        children.skipNonCode();
                        if (children.isToken('Punctuator', ',')) {
                            children.moveNext();
                            children.skipNonCode();
                        }
                    }
                    children.passToken('Punctuator', '}');
                } else {
                    // es2016 export from
                    specifiers.push(children.passModuleSpecifier());
                }
                children.skipNonCode();

                if (children.isToken('Identifier', 'from')) {
                    children.passToken('Identifier', 'from');
                    children.skipNonCode();
                    source = children.passNode('StringLiteral');
                    if (!children.isEnd) {
                        children.skipNonCode();
                        children.passToken('Punctuator', ';');
                    }
                } else if (!children.isEnd) {
                    children.passToken('Punctuator', ';');
                }
            }

            children.assertEnd();

            this.declaration = declaration;
            this.specifiers = specifiers;
            this.source = source;
        }
    }]);

    return ExportNamedDeclaration;
}(_ModuleDeclaration3.default);

exports.default = ExportNamedDeclaration;
//# sourceMappingURL=ExportNamedDeclaration.js.map