'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var _getFunctionParams = require('./utils/getFunctionParams');

var _getFunctionParams2 = _interopRequireDefault(_getFunctionParams);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FunctionDeclaration = function (_Statement) {
    _inherits(FunctionDeclaration, _Statement);

    function FunctionDeclaration(childNodes) {
        _classCallCheck(this, FunctionDeclaration);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(FunctionDeclaration).call(this, 'FunctionDeclaration', childNodes));

        _this.expression = false;
        _this.isFunction = true;
        return _this;
    }

    _createClass(FunctionDeclaration, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var params = void 0;
            var async = false;
            var id = null;

            if (children.isToken('Identifier', 'async')) {
                async = true;
                children.passToken('Identifier', 'async');
                children.skipNonCode();
            }

            children.passToken('Keyword', 'function');
            children.skipNonCode();

            var generator = false;
            if (children.isToken('Punctuator', '*')) {
                generator = true;
                children.moveNext();
                children.skipNonCode();
            }

            if (children.isNode('Identifier')) {
                id = children.passNode('Identifier');
                children.skipNonCode();
            }

            params = (0, _getFunctionParams2.default)(children);
            children.skipNonCode();

            var body = children.passStatement();

            children.assertEnd();

            this.async = async;
            this.id = id;
            this.params = params;
            this.body = body;
            this.generator = generator;
        }
    }]);

    return FunctionDeclaration;
}(_Statement3.default);

exports.default = FunctionDeclaration;
//# sourceMappingURL=FunctionDeclaration.js.map