'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO: create JSXBoundaryElement?

var JSXOpeningElement = function (_Node) {
    _inherits(JSXOpeningElement, _Node);

    function JSXOpeningElement(childNodes) {
        _classCallCheck(this, JSXOpeningElement);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(JSXOpeningElement).call(this, 'JSXOpeningElement', childNodes));
    }

    _createClass(JSXOpeningElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var attributes = [];
            var selfClosing = false;

            children.passToken('Punctuator', '<');
            children.skipNonCode();
            var name = children.passOneOfNode(['JSXIdentifier', 'JSXMemberExpression', 'JSXNamespacedName']);
            children.skipNonCode();

            while (true) {
                if (children.isNode('JSXAttribute')) {
                    children.skipNonCode();
                    attributes.push(children.passNode('JSXAttribute'));
                    children.skipNonCode();
                } else if (children.isNode('JSXSpreadAttribute')) {
                    children.skipNonCode();
                    attributes.push(children.passNode('JSXSpreadAttribute'));
                    children.skipNonCode();
                } else {
                    break;
                }
            }

            if (children.isToken('Punctuator', '/')) {
                children.skipNonCode();
                children.passToken('Punctuator', '/');
                selfClosing = true;
                children.skipNonCode();
            }

            children.passToken('Punctuator', '>');
            children.assertEnd();

            this.name = name;
            this.attributes = attributes;
            this.selfClosing = selfClosing;
        }
    }]);

    return JSXOpeningElement;
}(_Node3.default);

exports.default = JSXOpeningElement;
//# sourceMappingURL=JSXOpeningElement.js.map