'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TryStatement = function (_Statement) {
    _inherits(TryStatement, _Statement);

    function TryStatement(childNodes) {
        _classCallCheck(this, TryStatement);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TryStatement).call(this, 'TryStatement', childNodes));
    }

    _createClass(TryStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'try');
            children.skipNonCode();

            var block = children.passStatement('BlockStatement');
            children.skipNonCode();

            var handler = null;
            if (children.isNode('CatchClause')) {
                handler = children.passNode();
            }

            var finalizer = null;
            if (!children.isEnd) {
                children.skipNonCode();
                children.passToken('Keyword', 'finally');
                children.skipNonCode();
                finalizer = children.passStatement('BlockStatement');
            }

            children.assertEnd();

            this.block = block;
            this.finalizer = finalizer;
            this.handler = handler;
        }
    }]);

    return TryStatement;
}(_Statement3.default);

exports.default = TryStatement;
//# sourceMappingURL=TryStatement.js.map